/*
 * An opener for a file employing a rewritable memory area.
 *
 * Copyright (C) 2021, 2022 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <fsserver/host_file_opener.h>



/* Support for providing access to files. */

class BlockFileOpener : public HostFileOpener
{
public:
    explicit BlockFileOpener(ResourceRegistry *registry)
    : HostFileOpener(registry)
    {
    }

    virtual ~BlockFileOpener();

    /* Configurable methods. */

    virtual long get_fileid(const char *path, flags_t flags, fileid_t *fileid);

    virtual long make_accessor(flags_t flags, fileid_t fileid, Accessor **accessor);
};

// vim: tabstop=4 expandtab shiftwidth=4
